/* Algorithm from "Combinatorial Algorithms,"  Reingold, Nievergelt, Deo
   C implementation by Glenn C. Rhoads
*/

#include <stdio.h>
#include <stdlib.h>

int main(int argv, char** argc)
{
    int i = 0, j, n, *g, *t;

    printf( "Enter n: ");
n = 10; //    scanf( "%d", &n );

    g = malloc( (n+2) * sizeof(int));
    t = malloc( (n+2) * sizeof(int));

    for (j=0; j <= n+1; j++)
        {
        g[j] = 0;
        t[j] = j+1;
        }

    while (i < n+1)
        {
        for (j=n; j; j--) printf( "%2d", g[j]);
        printf("\n");

        i = t[0];
        g[i] = !g[i];
        t[0] = 1;
        t[i-1] = t[i];
        t[i] = i+1;
        }
}
